{

 changes to make
 -------------------------
 make main loop much tighter
   the whole thing is still way too slow. I think i need to be using multiple cogs
   
 fix ultrasound !!
   its aim is off. also its noisy(can i hear 40khtz?.. its gotta be busted)
   and i think its slowing down the strumming.
   i need to run it from its own cog, continually, giving me a continuous, 'debounced'
   velocity that doesn't slow down my main loop. i wonder if thats possible
   its just disabled alltogether for now.
    
 fix bouncy notes
   some notes just wont stop playing. resistor values are off or something.
   i think i need 1 trim pot for every receiver, user adjustable.

 add debug mode -    

 fix note offs - done
  in LMMS the notes don't go off when we strum again. they do when we switch chords
  i think the note needs to be killed before its played if the timer was active
  
 fix lasers. done
   i glued them all down. and still they wouldn't aim. they sucked
   so now i'm using omnidirectional lasers (light bulbs)
   3 white LEDS work fine for now, but the three light sources do still give me
   false triggers some times, since there are three shaddows hitting each cell

}

CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  PING_Pin     = 7
  CdS_4        = 8        'they are connected in kind of a random fashion
  CdS_6        = 9          
  CdS_5        = 10         
  CdS_1        = 11         
  CdS_3        = 12         
  CdS_2        = 13         
  midi_out_pin = 14
  kb_pin1      = 26
  kb_pin2      = 27
  midi_in_pin  = 28

  ping_max = 181    'max range for accurate ping reading
  ping_min = 60     'minimum range for accurate ping reading

  Ab_       = 0
  A_        = 1  'possible chords
  Bb_       = 2
  B_        = 3
  C_        = 4
  Db_       = 5
  D_        = 6
  Eb_       = 7
  E_        = 8
  F_        = 9
  Gb_       = 10
  G_        = 11
 
  Major        = 0 'chord quality
  Minor        = 1
  Seventh      = 2
  Maj7         = 3
  Min7         = 4
  Aug          = 5
  Sus          = 6
  Dim          = 7
  
    
VAR
  byte  j
   
  long  range

  byte CdS_1_wait
  byte CdS_2_wait
  byte CdS_3_wait
  byte CdS_4_wait
  byte CdS_5_wait
  byte CdS_6_wait

  long  string1_timer
  long  string2_timer
  long  string3_timer
  long  string4_timer
  long  string5_timer
  long  string6_timer

  byte string1_state
  byte string2_state
  byte string3_state
  byte string4_state
  byte string5_state
  byte string6_state
  
  byte string1_note
  byte string2_note  
  byte string3_note
  byte string4_note  
  byte string5_note
  byte string6_note  

  byte string1_velocity
  byte string2_velocity  
  byte string3_velocity
  byte string4_velocity  
  byte string5_velocity
  byte string6_velocity

  byte chord
  byte chord_quality 
  
  byte tranny  'how many semitones to transpose the notes 

OBJ
  LCD  : "LCD_mine"
  kb   : "keyboard"     
  midi : "FullDuplexSerial"
  ping : "ping"
  
PUB StrumBoard

  SetupVariables
  StartHardware

  'Main Loop
  repeat                 'the bad part, i need to put these in seperate cogs i think
    poll_cells
    update_strings
    update_keyboard

pub poll_cells

   'check state of CdS cells
    if(ina[CdS_1]==1)                        'if CdS_1 is high
       CdS_1_wait := 1                       'go into a waiting state
    if(ina[CdS_2]==1)                        
        CdS_2_wait := 1                      'this way notes only get triggered 
    if(ina[CdS_3]==1)                        'when the pins go from high to low
       CdS_3_wait := 1                       'instead of repeating while held low
    if(ina[CdS_4]==1)                        
       CdS_4_wait := 1                       
    if(ina[CdS_5]==1)                        
       CdS_5_wait := 1                       
    if(ina[CdS_6]==1)                       
       CdS_6_wait := 1                       
 

   if((ina[CdS_1]==0) & (CdS_1_wait == 1))  'when it goes high, while waiting         
      string1_timer := 10000                'start the note timer
      CdS_1_wait := 0                       'and reset the wait state
                           
   if((ina[CdS_2]==0) & (CdS_2_wait == 1))     
       string2_timer := 10000               
       CdS_2_wait := 0                       

   if((ina[CdS_3]==0) & (CdS_3_wait == 1))          
       string3_timer := 10000                
       CdS_3_wait := 0                      

   if((ina[CdS_4]==0) & (CdS_4_wait == 1))      
       string4_timer := 10000                
       CdS_4_wait := 0                      

   if((ina[CdS_5]==0) & (CdS_5_wait == 1))         
       string5_timer := 10000               
       CdS_5_wait := 0                      

   if((ina[CdS_6]==0) & (CdS_6_wait == 1))         
       string6_timer := 10000                
       CdS_6_wait := 0                       

pub StartHardware
  'set CdS pins to input
  DIRA[CdS_1] := 0
  DIRA[CdS_2] := 0
  DIRA[CdS_3] := 0
  DIRA[CdS_4] := 0
  DIRA[CdS_5] := 0
  DIRA[CdS_6] := 0
 

   
 'start up the subsystems   
  midi.start(midi_in_pin,midi_out_pin,0,31250) 'input,output,mode,baudrate 

  LCD.START 'start LCD
  'no error checking is needed here. if the LCD doesn't work, there is nothing
  'to use to tell the user there's a problem. it should be pretty obvious.
  
  kb.start(kb_pin1, kb_pin2) 'start keyboard

  LCD.MOVE(1,1)
  LCD.STR(STRING("S"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("Sy"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("Sys"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("Sys"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("Syst"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("Syste"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("System "))
  LCD.MOVE(1,1)
  LCD.STR(STRING("System T"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("System Te"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("System Tes"))
  LCD.MOVE(1,1)
  LCD.STR(STRING("System Test"))


'  waitcnt(clkfreq + cnt)  'wait for keyboard to boot up

  
  if(kb.present==0)
    LCD.MOVE(1,1)
    LCD.STR(STRING("keyboard error"))
    LCD.MOVE(1,2)
    LCD.STR(STRING("Press any key")) ' i love that joke
    kb.getkey 'wait for keypress on broken keyboard 
     

   'test sonar
'  range := ping.Millimeters(PING_Pin)
'  if((range>300) or (range <1))
'    LCD.MOVE(1,1)
'    LCD.STR(STRING("ping error "))
'    LCD.MOVE(1,2)
'    LCD.STR(STRING("Press any key"))
'    kb.getkey 
  
  LCD.MOVE(1,1)
  LCD.STR(STRING("All Systems Go"))

 
pub SetupVariables
 'define default values for variables
   tranny := 12
   
   CdS_1_wait := 0
   CdS_2_wait := 0
   CdS_3_wait := 0
   CdS_4_wait := 0
   CdS_5_wait := 0
   CdS_6_wait := 0
     
   string1_timer := 0
   string2_timer := 0
   string3_timer := 0
   string4_timer := 0
   string5_timer := 0
   string6_timer := 0

   string1_state := 0   'strings are all silent
   string2_state := 0
   string3_state := 0
   string4_state := 0
   string5_state := 0
   string6_state := 0

   chord := C_
   chord_quality := Major
      
   string1_note := C_Chords[0]
   string2_note := C_Chords[1]
   string3_note := C_Chords[2]
   string4_note := C_Chords[3]
   string5_note := C_Chords[4]
   string6_note := C_Chords[5]
   transpose_notes
   
   string1_velocity := 100
   string2_velocity := 100 
   string3_velocity := 100
   string4_velocity := 100 
   string5_velocity := 100
   string6_velocity := 100

pri update_keyboard  

   j := kb.key  'check keyboard buffer
   
   if(j) 'if a keystroke is in the buffer

      if(j == $CD) 'power button
        'this should trigger debugmode
        
     'change the chord
      if(j == $7A)  'z
        chord := C_

      if(j == $73)  's 
        chord := Db_

      if(j == $78)  'x 
        chord := D_

      if(j == $64)  'd 
        chord := Eb_

      if(j == $63)  'c 
        chord := E_

      if(j == $76)  'v 
        chord := F_

      if(j == $67)  'g 
        chord := Gb_

      if(j == $62)  'b 
        chord := G_

      if(j == $68)  'h 
        chord := Ab_

      if(j == $6E)  'n 
        chord := A_

      if(j == $6A)  'j 
        chord := Bb_

      if(j == $6D)  'm 
        chord := B_


    'or change the chord quality    
      if(j == $31)  '1 
        chord_quality := Major

      if(j == $32)  '2 
        chord_quality := Minor

      if(j == $33)  '3 
        chord_quality := Seventh

      if(j == $34)  '4 
        chord_quality := Maj7

      if(j == $35)  '5 
        chord_quality := Min7

      if(j == $36)  '6 
        chord_quality := Aug

      if(j == $37)  '7 
        chord_quality := Sus

      if(j == $38)  '8 
        chord_quality := Dim

 

     if(j>$38) ' if it was a letter(note), not a number(chord quality)    

        mute_notes 'mute all previous notes and reset timers

 
        'setup new notes
        'the (chord_quality*6) is the offset to the location in the data blcok
        'where that chord quality is located for any given key
     if(chord == Ab_)
          string1_note := BYTE[@Ab_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@Ab_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@Ab_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@Ab_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@Ab_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@Ab_Chords+(chord_quality*6)][5]
          transpose_notes
 

     if(chord == A_)
          string1_note := BYTE[@A_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@A_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@A_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@A_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@A_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@A_Chords+(chord_quality*6)][5]
          transpose_notes

 
     if(chord == Bb_)
          string1_note := BYTE[@Bb_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@Bb_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@Bb_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@Bb_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@Bb_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@Bb_Chords+(chord_quality*6)][5]
          transpose_notes


     if(chord == B_)
          string1_note := BYTE[@B_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@B_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@B_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@B_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@B_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@B_Chords+(chord_quality*6)][5]
          transpose_notes

           
     if(chord == C_)
          string1_note := BYTE[@C_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@C_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@C_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@C_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@C_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@C_Chords+(chord_quality*6)][5]
          transpose_notes


     if(chord == Db_)
          string1_note := BYTE[@Db_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@Db_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@Db_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@Db_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@Db_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@Db_Chords+(chord_quality*6)][5]
          transpose_notes


     if(chord == D_)
          string1_note := BYTE[@D_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@D_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@D_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@D_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@D_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@D_Chords+(chord_quality*6)][5]
          transpose_notes


     if(chord == Eb_)
          string1_note := BYTE[@Eb_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@Eb_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@Eb_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@Eb_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@Eb_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@Eb_Chords+(chord_quality*6)][5]
          transpose_notes


     if(chord == E_)
          string1_note := BYTE[@E_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@E_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@E_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@E_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@E_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@E_Chords+(chord_quality*6)][5]
          transpose_notes
 

     if(chord == F_)
          string1_note := BYTE[@F_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@F_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@F_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@F_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@F_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@F_Chords+(chord_quality*6)][5]
          transpose_notes

                                                               
     if(chord == Gb_)
          string1_note := BYTE[@Gb_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@Gb_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@Gb_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@Gb_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@Gb_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@Gb_Chords+(chord_quality*6)][5]
          transpose_notes

                                                               
     if(chord == G_)
          string1_note := BYTE[@G_Chords+(chord_quality*6)][0]
          string2_note := BYTE[@G_Chords+(chord_quality*6)][1]
          string3_note := BYTE[@G_Chords+(chord_quality*6)][2]
          string4_note := BYTE[@G_Chords+(chord_quality*6)][3]
          string5_note := BYTE[@G_Chords+(chord_quality*6)][4]
          string6_note := BYTE[@G_Chords+(chord_quality*6)][5]
          transpose_notes

     update_display

pub update_display
    LCD.MOVE(1,2)  
   if(chord == C_) 
      LCD.STR(STRING("C "))
   if(chord == Db_) 
      LCD.STR(STRING("C#"))
   if(chord == D_) 
      LCD.STR(STRING("D "))
   if(chord == Eb_) 
      LCD.STR(STRING("D#"))
   if(chord == E_) 
      LCD.STR(STRING("E "))
   if(chord == F_) 
      LCD.STR(STRING("F "))
   if(chord == Gb_) 
      LCD.STR(STRING("F#"))
   if(chord == G_) 
      LCD.STR(STRING("G "))
   if(chord == Ab_) 
      LCD.STR(STRING("G#"))
   if(chord == A_) 
      LCD.STR(STRING("A "))
   if(chord == Bb_) 
      LCD.STR(STRING("A#"))
   if(chord == B_) 
      LCD.STR(STRING("B "))

   LCD.MOVE(3,2)
    if(chord_quality == Major)
       LCD.STR(STRING("Major     "))   

    if(chord_quality == Minor)
       LCD.STR(STRING("Minor     "))   

    if(chord_quality == Seventh)
       LCD.STR(STRING("Seventh   "))

    if(chord_quality == Maj7)
       LCD.STR(STRING("Major 7th "))

    if(chord_quality == Min7)
       LCD.STR(STRING("Minor 7th "))

    if(chord_quality == Aug)
       LCD.STR(STRING("Augmented "))   

    if(chord_quality == Sus)
       LCD.STR(STRING("Suspended "))   

    if(chord_quality == Dim)
       LCD.STR(STRING("Diminished"))         

pub mute_notes

         midi.tx($80)   
         midi.tx(string1_note) 
         midi.tx(0)
         midi.tx($80)   
         midi.tx(string2_note) 
         midi.tx(0)
         midi.tx($80)   
         midi.tx(string3_note) 
         midi.tx(0)
         midi.tx($80)   
         midi.tx(string4_note) 
         midi.tx(0)
         midi.tx($80)   
         midi.tx(string5_note) 
         midi.tx(0)
         midi.tx($80)   
         midi.tx(string6_note) 
         midi.tx(0)

pub transpose_notes
     'adjust notes for transpose
     string1_note := string1_note - tranny
     string2_note := string2_note - tranny
     string3_note := string3_note - tranny
     string4_note := string4_note - tranny
     string5_note := string5_note - tranny
     string6_note := string6_note - tranny       
pri update_strings

 'if the strings were strummed AND this string for this chord isn't 0, start the note
  if((string1_timer == 10000) and (string1_note))
     if(string1_state) 'if the note was already playing, kill it
       midi.tx($80)              'note off signal
       midi.tx(string1_note)     'midi musical note
       midi.tx(0)                'volume 0      
    midi.tx($90)              'note on signal
    midi.tx(string1_note)     'midi note
    midi.tx(string1_velocity) 'volume
    string1_state := 1 'keep track, this note is now on
    
  if((string2_timer == 10000) and (string2_note))
     if(string2_state)
       midi.tx($80)             
       midi.tx(string2_note)     
       midi.tx(0)                
    midi.tx($90)   
    midi.tx(string2_note)    
    midi.tx(string2_velocity)  
    string2_state := 1 
    
  if((string3_timer == 10000) and (string3_note))
     if(string3_state)
       midi.tx($80)             
       midi.tx(string3_note)    
       midi.tx(0)               
    midi.tx($90)   '
    midi.tx(string3_note)   
    midi.tx(string3_velocity)   
    string3_state := 1 

  if((string4_timer == 10000) and (string4_note))
     if(string4_state)
       midi.tx($80)             
       midi.tx(string4_note)    
       midi.tx(0)               
    midi.tx($90)   
    midi.tx(string4_note)    
    midi.tx(string4_velocity)   
    string4_state := 1  

  if((string5_timer == 10000) and (string5_note))
     if(string5_state)
       midi.tx($80)              
       midi.tx(string5_note)     
       midi.tx(0)                
    midi.tx($90)  
    midi.tx(string5_note)    
    midi.tx(string5_velocity)   
    string5_state := 1 

  if((string6_timer == 10000) and (string6_note))
     if(string6_state)
       midi.tx($80)            
       midi.tx(string6_note)    
       midi.tx(0)               
    midi.tx($90)  
    midi.tx(string6_note)   
    midi.tx(string6_velocity)  
    string6_state := 1 

  'kill notes if its time for them to die------------------------  
  if(string1_timer == 1)
    midi.tx($80)              'note off signal
    midi.tx(string1_note)     'note
    midi.tx(0)                'volume
    string1_state := 0  ' this note is now off
    
  if(string2_timer == 1)
    midi.tx($80)  
    midi.tx(string2_note)     
    midi.tx(0)      
    string2_state := 0 

  if(string3_timer == 1)
    midi.tx($80)   
    midi.tx(string3_note)   
    midi.tx(0)     
    string3_state := 0 

  if(string4_timer == 1)
    midi.tx($80)  
    midi.tx(string4_note)    
    midi.tx(0)   
    string4_state := 0  

  if(string5_timer == 1)
    midi.tx($80)   
    midi.tx(string5_note)    
    midi.tx(0)     
    string5_state := 0 

  if(string6_timer == 1)
    midi.tx($80)    
    midi.tx(string6_note)
    midi.tx(0)     
    string6_state := 0  

 'countdown the string timer------------------
 if(string1_timer)
    string1_timer := (string1_timer-1)

 if(string2_timer)
   string2_timer := (string2_timer-1)

 if(string3_timer)
   string3_timer := (string3_timer-1)

 if(string4_timer)
   string4_timer := (string4_timer-1)

 if(string5_timer)
   string5_timer := (string5_timer-1)

 if(string6_timer)
   string6_timer := (string6_timer-1)

DAT
'midi notes for each guitar chord
'listed string 1 to string 6

                'major                7th                Maj7                Sus                 Min                 Min7                Aug                Dim                                                       
Ab_Chords   byte 56,63,68,72,75,80,   0, 0,63,68,72,78,  0, 0,63,68,72,79,   0, 0,63,68,73,80,  57,63,68,71,76,80,  0, 0,63,68,71,78,   0, 0,64,68,72,76,  0,59,65,68,74,77 
G_Chords    byte 55,59,62,67,71,74,  55,59,62,67,71,77, 55,59,62,67,71,78,  55,60,67,72,74,79,  55,62,67,70,74,79,  55,62,65,70,74,79,  0, 0,63,67,71,79,  0,58,64,67,73,76
Gb_Chords   byte 54,61,66,70,73,78,   0,61,64,70,73,78,  0, 0,66,70,73,77,  54,59,66,71,73,78,  54,61,66,69,73,78,  54,61,64,69,73,78,  0, 0,62,70,74,78,  0,60,66,69,75,77  
F_Chords    byte 53,60,65,69,72,77,  53,60,63,69,72,77,  0, 0,65,69,72,76,  53,58,65,70,72,77,  53,60,65,68,72,77,  53,60,63,68,72,77,  0, 0,65,69,73,77,  0,59,65,68,74,77
E_Chords    byte 52,59,64,68,71,76,  52,59,62,68,71,76,  0, 0,64,71,75,80,   0, 0,64,69,71,76,  52,59,64,67,71,76,  52,59,62,67,71,76,  0, 0,64,68,72,76,  0,58,64,67,73,76
Eb_Chords   byte 0, 0,67,70,75,79,    0, 0,63,70,73,79,  0, 0,63,70,74,79,   0, 0, 0,70,75,80,  0, 0,66,70,75,78,   0, 0,63,70,73,78,   0, 0,63,67,71,79,  0,60,66,69,75,78
D_Chords    byte 0, 0,62,69,74,78,    0,0,62,69,72,78,   0,0,62,69,73,78,    0,0,62,69,74,79,   0,0,62,69,74,77,    0,0,62,69,72,77,    0,0,62,70,74,78,   0,0,62,68,71,77
Db_Chords   byte 0, 0,65,68,73,78,    0, 0,65,71,73,80,  0,61,65,70,72,77,   0, 0,68,73,78,80,  0, 0,64,68,73,76,   0, 0,64,71,73,80,   0, 0,65,69,73,77,  0,58,64,67,73,76
C_Chords    byte 55,60,64,67,72,76,   0,60,64,70,72,76, 55,60,64,67,71,76,   0, 0,67,72,77,79,  0,60,67,72,75,79,   0,60,67,70,75,79,   0,60,64,68,73,76,  0,60,66,69,75,78
B_Chords    byte 0,59,66,71,75,78,    0,59,63,69,71,78,  0,59,66,70,75,78,   0, 0,66,71,76,78,  0,59,66,71,74,78,   0,59,66,69,74,78,   0, 0,63,67,71,79,  0,59,65,68,74,77
Bb_Chords   byte 0,58,65,70,74,77,    0,58,65,68,74,77,  0,58,65,69,74,77,   0, 0,65,70,75,77,  0,58,65,70,73,77,   0,58,65,68,73,77,   0, 0,66,70,74,78,  0,58,64,67,73,76
A_Chords    byte 0,57,64,69,73,76,    0,57,64,67,73,76,  0,57,64,68,73,76,   0,57,64,69,74,76,  0,57,64,69,72,76,   0,57,64,67,72,76,   0, 0,65,69,73,77,  0,60,66,69,75,78
 